# -*- coding: utf-8 -*-
from openerp import models, fields, tools, api

class AccountBankStatementUtility(models.Model):
    _inherit = 'account.bank.statement'

    '''
        get_account_bank_statement_utility
    '''
    @api.model
    def get_account_bank_statement_utility(self, id):
        print('\n\nget_account_bank_statement_utility\n\n')
        bankStatement = self.env['account.bank.statement'].browse(id)

        if (not bankStatement):
            return False

        accountStatement = []
        amount = 0.0
        for line in bankStatement.line_ids:
            amount += line.amount

        accountStatement.append({
            'id': bankStatement.id,
            'name': bankStatement.name,
            'date': bankStatement.date,
            'journalId': bankStatement.journal_id.id,
            'periodId': bankStatement.period_id.id,
            'userId': bankStatement.user_id.id,
            'userName': bankStatement.user_id.name,
            'posSessionName': bankStatement.pos_session_id.name,
            'typeStatement': bankStatement.type_statement,
            'amount': amount
        })

        return accountStatement
